--- Glitter.orig/templates/include_history.tmpl	2017-02-25 09:22:49.110187900 -0800
+++ Glitter/templates/include_history.tmpl	2017-02-25 09:29:34.439969000 -0800
@@ -1,5 +1,18 @@
 <div class="history" id="history-tab" data-bind="visible: hasHistory() || displayTabbed()" style="display: none">

     <h2>$T('menu-history')</h2>

+

+    <div class="input-group search-box">

+        <input type="text" class="form-control" placeholder="$T('Glitter-search')" required data-bind="textInput: history.searchTerm, event: { keydown: history.clearSearchTerm }" />

+        <a data-bind="event: { mousedown: history.clearSearchTerm }">

+            <span class="glyphicon" data-bind="css: { 'glyphicon-search' : !history.searchTerm(), 'glyphicon-remove' : history.searchTerm() }"></span>

+        </a>

+    </div>

+

+    <div class="multioperations-selector" id="history-options">

+        <a href="#" class="hover-button" title="$T('showAllHis') / $T('showFailedHis')" data-tooltip="true" data-placement="left" data-bind="click: history.toggleShowFailed, css: { 'history-options-show-failed': history.showFailed }"><span class="glyphicon glyphicon-exclamation-sign"></span></a>

+        <a href="#modal-purge-history" class="hover-button" title="$T('purgeHist')" data-toggle="modal" data-tooltip="true" data-placement="left"><span class="glyphicon glyphicon-trash"></span></a>

+    </div>

+

     <table class="table table-hover history-table paginated">

         <thead>

             <tr>

@@ -192,24 +205,12 @@
         </tbody>

     </table>

 

-    <div class="input-group search-box">

-        <input type="text" class="form-control" placeholder="$T('Glitter-search')" required data-bind="textInput: history.searchTerm, event: { keydown: history.clearSearchTerm }" />

-        <a data-bind="event: { mousedown: history.clearSearchTerm }">

-            <span class="glyphicon" data-bind="css: { 'glyphicon-search' : !history.searchTerm(), 'glyphicon-remove' : history.searchTerm() }"></span>

-        </a>

-    </div>

-

     <ul class="pagination" data-bind="foreach: history.pagination.allpages(), visible: history.pagination.hasPagination" style="display: none;">

         <li data-bind="css: { active: isCurrent, disabled: isDots }, click: onclick">

             <span data-bind="text: page"></span>

         </li>

     </ul>

 

-    <div class="multioperations-selector" id="history-options">

-        <a href="#" class="hover-button" title="$T('showAllHis') / $T('showFailedHis')" data-tooltip="true" data-placement="left" data-bind="click: history.toggleShowFailed, css: { 'history-options-show-failed': history.showFailed }"><span class="glyphicon glyphicon-exclamation-sign"></span></a>

-        <a href="#modal-purge-history" class="hover-button" title="$T('purgeHist')" data-toggle="modal" data-tooltip="true" data-placement="left"><span class="glyphicon glyphicon-trash"></span></a>

-    </div>

-

     <div class="info-container history-info">

         <span class="glyphicon glyphicon-save"></span>

         <span data-bind="text: history.downloadedToday"></span>B $T('Glitter-today')

--- Glitter.orig/templates/include_queue.tmpl	2017-02-25 09:22:49.125814100 -0800
+++ Glitter/templates/include_queue.tmpl	2017-02-25 09:29:31.464518800 -0800
@@ -1,6 +1,13 @@
 <div class="queue active" id="queue-tab">

     <h2>$T('menu-queue')</h2>

 

+    <div class="input-group search-box" data-bind="visible: queue.hasQueueSearch" style="display: none;">

+        <input type="text" class="form-control" placeholder="$T('Glitter-search')" required data-bind="textInput: queue.searchTerm, event: { keydown: queue.clearSearchTerm }" />

+        <a data-bind="event: { mousedown: queue.clearSearchTerm }">

+            <span class="glyphicon" data-bind="css: { 'glyphicon-search' : !queue.searchTerm(), 'glyphicon-remove' : queue.searchTerm() }"></span>

+        </a>

+    </div>

+

     <div class="info-container" data-bind="visible: diskSpaceLeft1()" style="display: none;">

         <!-- ko if: hasWarnings()  -->

         <div class="info-container-box">

@@ -204,13 +211,6 @@
         <div class="clearfix"></div>

     </form>

 

-    <div class="input-group search-box" data-bind="visible: queue.hasQueueSearch" style="display: none;">

-        <input type="text" class="form-control" placeholder="$T('Glitter-search')" required data-bind="textInput: queue.searchTerm, event: { keydown: queue.clearSearchTerm }" />

-        <a data-bind="event: { mousedown: queue.clearSearchTerm }">

-            <span class="glyphicon" data-bind="css: { 'glyphicon-search' : !queue.searchTerm(), 'glyphicon-remove' : queue.searchTerm() }"></span>

-        </a>

-    </div>

-

     <ul class="pagination" data-bind="foreach: queue.pagination.allpages, visible: queue.pagination.hasPagination" style="display: none;">

         <li data-bind="css: { active: isCurrent, disabled: isDots }, click: onclick">

             <span data-bind="text: page"></span>

--- Glitter.orig/templates/static/stylesheets/glitter.css	2017-02-25 09:22:49.453952200 -0800
+++ Glitter/templates/static/stylesheets/glitter.css	2017-02-25 09:30:42.832108500 -0800
@@ -511,7 +511,7 @@
     position: relative;

 }

 

-.queue h2 {

+.queue h2, .history h2 {

     float: left;

 }

 

@@ -1136,8 +1136,7 @@
 

 .search-box {

     float: left;

-    margin-bottom: 10px;

-    margin-right: 5px;

+    margin-left: 10px;

 }

 

 .search-box input {